package eu.openaire.urls_worker.models;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;

import java.util.Date;


@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
        "id",
        "original_url",
        "datasource",
        "workerId",
        "date"
})
public class Assignment {

    @JsonProperty("id")
    private String id;

    @JsonProperty("original_url")
    private String originalUrl;

    @JsonProperty("datasource")
    private Datasource datasource;

    @JsonProperty("workerid")
    private String workerId;

    @JsonProperty("date")
    private Date date;


    public Assignment() {}


    public Assignment(String id, String originalUrl, Datasource datasource, String workerId, Date date) {
        this.id = id;
        this.originalUrl = originalUrl;
        this.datasource = datasource;
        this.workerId = workerId;
        this.date = date;
    }


    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getOriginalUrl() {
        return originalUrl;
    }

    public void setOriginalUrl(String originalUrl) {
        this.originalUrl = originalUrl;
    }

    public Datasource getDatasource() {
        return datasource;
    }

    public void setDatasource(Datasource datasource) {
        this.datasource = datasource;
    }

    public String getWorkerId() {
        return workerId;
    }

    public void setWorkerId(String workerId) {
        this.workerId = workerId;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }


    @Override
    public String toString() {
        return "Assignment{" +
                "id='" + id + '\'' +
                ", originalUrl='" + originalUrl + '\'' +
                ", datasource=" + datasource +
                ", workerId='" + workerId + '\'' +
                ", date=" + date +
                '}';
    }
}
